package pong.example;

import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = true;
	public static final boolean includeTitle = false;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "pong.example", "pong.example.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "pong.example", "pong.example.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "pong.example.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
        try {
            if (processBA.subExists("activity_actionbarhomeclick")) {
                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
                    getClass().getMethod("getActionBar").invoke(this), true);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
        
		return true;
	}   
 @Override
 public boolean onOptionsItemSelected(android.view.MenuItem item) {
    if (item.getItemId() == 16908332) {
        processBA.raiseEvent(null, "activity_actionbarhomeclick");
        return true;
    }
    else
        return super.onOptionsItemSelected(item); 
}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static anywheresoftware.b4a.objects.Timer _main_engine = null;
public anywheresoftware.b4a.objects.PanelWrapper _p1_controls = null;
public anywheresoftware.b4a.objects.PanelWrapper _p2_controls = null;
public anywheresoftware.b4a.objects.PanelWrapper _p1 = null;
public anywheresoftware.b4a.objects.PanelWrapper _p2 = null;
public anywheresoftware.b4a.objects.PanelWrapper _ball = null;
public static float _ball_speed = 0f;
public static float _ball_direction_x = 0f;
public static float _ball_direction_y = 0f;
public static float _v6 = 0f;
public static float _v7 = 0f;
public static float _v0 = 0f;
public static float _vv1 = 0f;
public static float _vv2 = 0f;
public static float _vv3 = 0f;
public static float _vv4 = 0f;
public static float _vv5 = 0f;
public static int _p1_score = 0;
public static int _p2_score = 0;
public static boolean _v5 = false;
public anywheresoftware.b4a.objects.LabelWrapper _player1_score = null;
public anywheresoftware.b4a.objects.LabelWrapper _player2_score = null;

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 57;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 59;BA.debugLine="Activity.LoadLayout(\"Game\")";
mostCurrent._activity.LoadLayout("Game",mostCurrent.activityBA);
 //BA.debugLineNum = 61;BA.debugLine="P1_Controls.Width = 50%x";
mostCurrent._p1_controls.setWidth(anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (50),mostCurrent.activityBA));
 //BA.debugLineNum = 62;BA.debugLine="P1_Controls.Height = 100%y";
mostCurrent._p1_controls.setHeight(anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (100),mostCurrent.activityBA));
 //BA.debugLineNum = 63;BA.debugLine="P1_Controls.Top = 0%y";
mostCurrent._p1_controls.setTop(anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (0),mostCurrent.activityBA));
 //BA.debugLineNum = 64;BA.debugLine="P1_Controls.Left = 0%x";
mostCurrent._p1_controls.setLeft(anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (0),mostCurrent.activityBA));
 //BA.debugLineNum = 66;BA.debugLine="P2_Controls.Width = 50%x";
mostCurrent._p2_controls.setWidth(anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (50),mostCurrent.activityBA));
 //BA.debugLineNum = 67;BA.debugLine="P2_Controls.Height = 100%y";
mostCurrent._p2_controls.setHeight(anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (100),mostCurrent.activityBA));
 //BA.debugLineNum = 68;BA.debugLine="P2_Controls.Top = 0%y";
mostCurrent._p2_controls.setTop(anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (0),mostCurrent.activityBA));
 //BA.debugLineNum = 69;BA.debugLine="P2_Controls.Left = 50%x";
mostCurrent._p2_controls.setLeft(anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (50),mostCurrent.activityBA));
 //BA.debugLineNum = 71;BA.debugLine="P1.Width = 2%x";
mostCurrent._p1.setWidth(anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (2),mostCurrent.activityBA));
 //BA.debugLineNum = 72;BA.debugLine="P1.Height = 24%y";
mostCurrent._p1.setHeight(anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (24),mostCurrent.activityBA));
 //BA.debugLineNum = 73;BA.debugLine="P1.Left = 10%x";
mostCurrent._p1.setLeft(anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (10),mostCurrent.activityBA));
 //BA.debugLineNum = 74;BA.debugLine="P1.Top = 50%y - (P1.Height / 2)";
mostCurrent._p1.setTop((int) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (50),mostCurrent.activityBA)-(mostCurrent._p1.getHeight()/(double)2)));
 //BA.debugLineNum = 76;BA.debugLine="P2.Width = P1.Width";
mostCurrent._p2.setWidth(mostCurrent._p1.getWidth());
 //BA.debugLineNum = 77;BA.debugLine="P2.Height = P1.Height";
mostCurrent._p2.setHeight(mostCurrent._p1.getHeight());
 //BA.debugLineNum = 78;BA.debugLine="P2.Left = 90%x - P1.Width";
mostCurrent._p2.setLeft((int) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (90),mostCurrent.activityBA)-mostCurrent._p1.getWidth()));
 //BA.debugLineNum = 79;BA.debugLine="P2.Top = P1.Top";
mostCurrent._p2.setTop(mostCurrent._p1.getTop());
 //BA.debugLineNum = 81;BA.debugLine="Ball.Width = 4%x";
mostCurrent._ball.setWidth(anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (4),mostCurrent.activityBA));
 //BA.debugLineNum = 82;BA.debugLine="Ball.Height = Ball.Width";
mostCurrent._ball.setHeight(mostCurrent._ball.getWidth());
 //BA.debugLineNum = 83;BA.debugLine="Ball.Left = 50%x - (Ball.Width / 2)";
mostCurrent._ball.setLeft((int) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (50),mostCurrent.activityBA)-(mostCurrent._ball.getWidth()/(double)2)));
 //BA.debugLineNum = 84;BA.debugLine="Ball.Top = 50%y - (Ball.Height / 2)";
mostCurrent._ball.setTop((int) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (50),mostCurrent.activityBA)-(mostCurrent._ball.getHeight()/(double)2)));
 //BA.debugLineNum = 86;BA.debugLine="Player1_Score.Width = 30%x";
mostCurrent._player1_score.setWidth(anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (30),mostCurrent.activityBA));
 //BA.debugLineNum = 87;BA.debugLine="Player1_Score.Height = 20%y";
mostCurrent._player1_score.setHeight(anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (20),mostCurrent.activityBA));
 //BA.debugLineNum = 88;BA.debugLine="Player1_Score.Left = 25%x - (Player1_Score.Width / 2)";
mostCurrent._player1_score.setLeft((int) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (25),mostCurrent.activityBA)-(mostCurrent._player1_score.getWidth()/(double)2)));
 //BA.debugLineNum = 89;BA.debugLine="Player1_Score.Top = 50%y - (Player1_Score.Height / 2)";
mostCurrent._player1_score.setTop((int) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (50),mostCurrent.activityBA)-(mostCurrent._player1_score.getHeight()/(double)2)));
 //BA.debugLineNum = 91;BA.debugLine="Player2_Score.Width = 30%x";
mostCurrent._player2_score.setWidth(anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (30),mostCurrent.activityBA));
 //BA.debugLineNum = 92;BA.debugLine="Player2_Score.Height = 20%y";
mostCurrent._player2_score.setHeight(anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (20),mostCurrent.activityBA));
 //BA.debugLineNum = 93;BA.debugLine="Player2_Score.Left = 75%x - (Player2_Score.Width / 2)";
mostCurrent._player2_score.setLeft((int) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (75),mostCurrent.activityBA)-(mostCurrent._player2_score.getWidth()/(double)2)));
 //BA.debugLineNum = 94;BA.debugLine="Player2_Score.Top = 50%y - (Player2_Score.Height / 2)";
mostCurrent._player2_score.setTop((int) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (50),mostCurrent.activityBA)-(mostCurrent._player2_score.getHeight()/(double)2)));
 //BA.debugLineNum = 96;BA.debugLine="P1_Controls.BringToFront";
mostCurrent._p1_controls.BringToFront();
 //BA.debugLineNum = 97;BA.debugLine="P2_Controls.BringToFront";
mostCurrent._p2_controls.BringToFront();
 //BA.debugLineNum = 99;BA.debugLine="Main_Engine.Initialize(\"Main_Engine\", 16)";
_main_engine.Initialize(processBA,"Main_Engine",(long) (16));
 //BA.debugLineNum = 100;BA.debugLine="Main_Engine.Enabled = True";
_main_engine.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 102;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 187;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 188;BA.debugLine="Pause = True";
_v5 = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 189;BA.debugLine="Main_Engine.Enabled = False";
_main_engine.setEnabled(anywheresoftware.b4a.keywords.Common.False);
 //BA.debugLineNum = 190;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 182;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 183;BA.debugLine="Pause = True";
_v5 = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 184;BA.debugLine="Main_Engine.Enabled = True";
_main_engine.setEnabled(anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 185;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _globals() throws Exception{
 //BA.debugLineNum = 23;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 27;BA.debugLine="Private P1_Controls As Panel";
mostCurrent._p1_controls = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 28;BA.debugLine="Private P2_Controls As Panel";
mostCurrent._p2_controls = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 29;BA.debugLine="Private P1 As Panel";
mostCurrent._p1 = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 30;BA.debugLine="Private P2 As Panel";
mostCurrent._p2 = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 31;BA.debugLine="Private Ball As Panel";
mostCurrent._ball = new anywheresoftware.b4a.objects.PanelWrapper();
 //BA.debugLineNum = 33;BA.debugLine="Dim ball_speed = 10dip As Float";
_ball_speed = (float) (anywheresoftware.b4a.keywords.Common.DipToCurrent((int) (10)));
 //BA.debugLineNum = 34;BA.debugLine="Dim ball_direction_x = ball_speed As Float";
_ball_direction_x = _ball_speed;
 //BA.debugLineNum = 35;BA.debugLine="Dim ball_direction_y = ball_speed As Float";
_ball_direction_y = _ball_speed;
 //BA.debugLineNum = 37;BA.debugLine="Dim P1startX As Float";
_v6 = 0f;
 //BA.debugLineNum = 38;BA.debugLine="Dim P1startY As Float";
_v7 = 0f;
 //BA.debugLineNum = 39;BA.debugLine="Dim P1deltaX As Float";
_v0 = 0f;
 //BA.debugLineNum = 40;BA.debugLine="Dim P1deltaY As Float";
_vv1 = 0f;
 //BA.debugLineNum = 42;BA.debugLine="Dim P2startX As Float";
_vv2 = 0f;
 //BA.debugLineNum = 43;BA.debugLine="Dim P2startY As Float";
_vv3 = 0f;
 //BA.debugLineNum = 44;BA.debugLine="Dim P2deltaX As Float";
_vv4 = 0f;
 //BA.debugLineNum = 45;BA.debugLine="Dim P2deltaY As Float";
_vv5 = 0f;
 //BA.debugLineNum = 47;BA.debugLine="Dim p1_score = 0 As Int";
_p1_score = (int) (0);
 //BA.debugLineNum = 48;BA.debugLine="Dim p2_score = 0 As Int";
_p2_score = (int) (0);
 //BA.debugLineNum = 50;BA.debugLine="Dim Pause = True As Boolean";
_v5 = anywheresoftware.b4a.keywords.Common.True;
 //BA.debugLineNum = 52;BA.debugLine="Private Player1_Score As Label";
mostCurrent._player1_score = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 53;BA.debugLine="Private Player2_Score As Label";
mostCurrent._player2_score = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 55;BA.debugLine="End Sub";
return "";
}
public static String  _main_engine_tick() throws Exception{
 //BA.debugLineNum = 104;BA.debugLine="Sub Main_Engine_Tick";
 //BA.debugLineNum = 106;BA.debugLine="Player1_Score.Text = p1_score";
mostCurrent._player1_score.setText((Object)(_p1_score));
 //BA.debugLineNum = 107;BA.debugLine="Player2_Score.Text = p2_score";
mostCurrent._player2_score.setText((Object)(_p2_score));
 //BA.debugLineNum = 110;BA.debugLine="If Ball.Left < P1.Left + P1.Width _ 			AND (Ball.Top + Ball.Height < P1.Top OR Ball.top > P1.Top + P1.Height) Then";
if (mostCurrent._ball.getLeft()<mostCurrent._p1.getLeft()+mostCurrent._p1.getWidth() && (mostCurrent._ball.getTop()+mostCurrent._ball.getHeight()<mostCurrent._p1.getTop() || mostCurrent._ball.getTop()>mostCurrent._p1.getTop()+mostCurrent._p1.getHeight())) { 
 //BA.debugLineNum = 112;BA.debugLine="Ball.Left = 50%x - (Ball.Width / 2)";
mostCurrent._ball.setLeft((int) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (50),mostCurrent.activityBA)-(mostCurrent._ball.getWidth()/(double)2)));
 //BA.debugLineNum = 113;BA.debugLine="Ball.Top = 50%y - (Ball.Height / 2)";
mostCurrent._ball.setTop((int) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (50),mostCurrent.activityBA)-(mostCurrent._ball.getHeight()/(double)2)));
 //BA.debugLineNum = 114;BA.debugLine="p2_score = p2_score + 1";
_p2_score = (int) (_p2_score+1);
 //BA.debugLineNum = 115;BA.debugLine="Pause = True";
_v5 = anywheresoftware.b4a.keywords.Common.True;
 };
 //BA.debugLineNum = 119;BA.debugLine="If Ball.Left + Ball.Width > P2.Left _ 			AND (Ball.Top + Ball.Height < P2.Top OR Ball.top > P2.Top + P2.Height) Then";
if (mostCurrent._ball.getLeft()+mostCurrent._ball.getWidth()>mostCurrent._p2.getLeft() && (mostCurrent._ball.getTop()+mostCurrent._ball.getHeight()<mostCurrent._p2.getTop() || mostCurrent._ball.getTop()>mostCurrent._p2.getTop()+mostCurrent._p2.getHeight())) { 
 //BA.debugLineNum = 121;BA.debugLine="Ball.Left = 50%x - (Ball.Width / 2)";
mostCurrent._ball.setLeft((int) (anywheresoftware.b4a.keywords.Common.PerXToCurrent((float) (50),mostCurrent.activityBA)-(mostCurrent._ball.getWidth()/(double)2)));
 //BA.debugLineNum = 122;BA.debugLine="Ball.Top = 50%y - (Ball.Height / 2)";
mostCurrent._ball.setTop((int) (anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (50),mostCurrent.activityBA)-(mostCurrent._ball.getHeight()/(double)2)));
 //BA.debugLineNum = 123;BA.debugLine="p1_score = p1_score + 1";
_p1_score = (int) (_p1_score+1);
 //BA.debugLineNum = 124;BA.debugLine="Pause = True";
_v5 = anywheresoftware.b4a.keywords.Common.True;
 };
 //BA.debugLineNum = 128;BA.debugLine="If (Ball.Left + Ball.Width) > P2.Left Then ball_direction_x = -ball_direction_x";
if ((mostCurrent._ball.getLeft()+mostCurrent._ball.getWidth())>mostCurrent._p2.getLeft()) { 
_ball_direction_x = (float) (-_ball_direction_x);};
 //BA.debugLineNum = 129;BA.debugLine="If Ball.Left < (P1.Left  + P1.Width) Then ball_direction_x = -ball_direction_x";
if (mostCurrent._ball.getLeft()<(mostCurrent._p1.getLeft()+mostCurrent._p1.getWidth())) { 
_ball_direction_x = (float) (-_ball_direction_x);};
 //BA.debugLineNum = 130;BA.debugLine="If (Ball.Top + Ball.Height) > 100%y Then ball_direction_y = -ball_direction_y";
if ((mostCurrent._ball.getTop()+mostCurrent._ball.getHeight())>anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (100),mostCurrent.activityBA)) { 
_ball_direction_y = (float) (-_ball_direction_y);};
 //BA.debugLineNum = 131;BA.debugLine="If Ball.Top < 0%y Then ball_direction_y = -ball_direction_y";
if (mostCurrent._ball.getTop()<anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (0),mostCurrent.activityBA)) { 
_ball_direction_y = (float) (-_ball_direction_y);};
 //BA.debugLineNum = 133;BA.debugLine="If Pause = False Then";
if (_v5==anywheresoftware.b4a.keywords.Common.False) { 
 //BA.debugLineNum = 134;BA.debugLine="Ball.Left = Ball.Left + ball_direction_x";
mostCurrent._ball.setLeft((int) (mostCurrent._ball.getLeft()+_ball_direction_x));
 //BA.debugLineNum = 135;BA.debugLine="Ball.Top = Ball.Top + ball_direction_y";
mostCurrent._ball.setTop((int) (mostCurrent._ball.getTop()+_ball_direction_y));
 };
 //BA.debugLineNum = 138;BA.debugLine="End Sub";
return "";
}
public static String  _p1_controls_touch(int _action,float _x,float _y) throws Exception{
 //BA.debugLineNum = 141;BA.debugLine="Sub P1_Controls_Touch (Action As Int, X As Float, Y As Float)";
 //BA.debugLineNum = 142;BA.debugLine="Select Action";
switch (BA.switchObjectToInt(_action,mostCurrent._activity.ACTION_DOWN,mostCurrent._activity.ACTION_MOVE)) {
case 0:
 //BA.debugLineNum = 144;BA.debugLine="P1startX = X";
_v6 = _x;
 //BA.debugLineNum = 145;BA.debugLine="P1startY = Y";
_v7 = _y;
 break;
case 1:
 //BA.debugLineNum = 148;BA.debugLine="Pause = False";
_v5 = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 149;BA.debugLine="P1deltaX = X - P1startX";
_v0 = (float) (_x-_v6);
 //BA.debugLineNum = 150;BA.debugLine="P1deltaY = Y - P1startY";
_vv1 = (float) (_y-_v7);
 //BA.debugLineNum = 151;BA.debugLine="P1startX = X";
_v6 = _x;
 //BA.debugLineNum = 152;BA.debugLine="P1startY = Y";
_v7 = _y;
 //BA.debugLineNum = 154;BA.debugLine="If (P1.Top + P1deltaY) > 0%y AND (P1.Top + P1.Height + P1deltaY) < 100%y Then";
if ((mostCurrent._p1.getTop()+_vv1)>anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (0),mostCurrent.activityBA) && (mostCurrent._p1.getTop()+mostCurrent._p1.getHeight()+_vv1)<anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (100),mostCurrent.activityBA)) { 
 //BA.debugLineNum = 155;BA.debugLine="P1.Top = P1.Top + P1deltaY * 1.5";
mostCurrent._p1.setTop((int) (mostCurrent._p1.getTop()+_vv1*1.5));
 };
 break;
}
;
 //BA.debugLineNum = 159;BA.debugLine="End Sub";
return "";
}
public static String  _p2_controls_touch(int _action,float _x,float _y) throws Exception{
 //BA.debugLineNum = 162;BA.debugLine="Sub P2_Controls_Touch (Action As Int, X As Float, Y As Float)";
 //BA.debugLineNum = 163;BA.debugLine="Select Action";
switch (BA.switchObjectToInt(_action,mostCurrent._activity.ACTION_DOWN,mostCurrent._activity.ACTION_MOVE)) {
case 0:
 //BA.debugLineNum = 165;BA.debugLine="P2startX = X";
_vv2 = _x;
 //BA.debugLineNum = 166;BA.debugLine="P2startY = Y";
_vv3 = _y;
 break;
case 1:
 //BA.debugLineNum = 169;BA.debugLine="Pause = False";
_v5 = anywheresoftware.b4a.keywords.Common.False;
 //BA.debugLineNum = 170;BA.debugLine="P2deltaX = X - P2startX";
_vv4 = (float) (_x-_vv2);
 //BA.debugLineNum = 171;BA.debugLine="P2deltaY = Y - P2startY";
_vv5 = (float) (_y-_vv3);
 //BA.debugLineNum = 172;BA.debugLine="P2startX = X";
_vv2 = _x;
 //BA.debugLineNum = 173;BA.debugLine="P2startY = Y";
_vv3 = _y;
 //BA.debugLineNum = 175;BA.debugLine="If (P2.Top + P2deltaY) > 0%y AND (P2.Top + P2.Height + P2deltaY) < 100%y Then";
if ((mostCurrent._p2.getTop()+_vv5)>anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (0),mostCurrent.activityBA) && (mostCurrent._p2.getTop()+mostCurrent._p2.getHeight()+_vv5)<anywheresoftware.b4a.keywords.Common.PerYToCurrent((float) (100),mostCurrent.activityBA)) { 
 //BA.debugLineNum = 176;BA.debugLine="P2.Top = P2.Top + P2deltaY * 1.5";
mostCurrent._p2.setTop((int) (mostCurrent._p2.getTop()+_vv5*1.5));
 };
 break;
}
;
 //BA.debugLineNum = 180;BA.debugLine="End Sub";
return "";
}
public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 15;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 19;BA.debugLine="Dim Main_Engine As Timer";
_main_engine = new anywheresoftware.b4a.objects.Timer();
 //BA.debugLineNum = 21;BA.debugLine="End Sub";
return "";
}
}
